import{s as ee,o as te,n as Z}from"../chunks/scheduler.d627b047.js";import{S as ne,i as oe,g as c,s as d,r as v,A as ae,h as u,f as a,c as m,j as q,u as _,x as L,k as B,y as E,a as l,v as w,d as b,t as k,w as P}from"../chunks/index.d48c4817.js";import{D as X}from"../chunks/Docstring.270658d8.js";import{H as V}from"../chunks/Heading.47e562a9.js";import{H as ie,a as Y}from"../chunks/HfOption.84c24d39.js";function se(y){let t,f="The abstract from the paper is:",s,i,n="<em>A modular design encourages neural models to disentangle and recombine different facets of knowledge to generalise more systematically to new tasks. In this work, we assume that each task is associated with a subset of latent discrete skills from a (potentially small) inventory. In turn, skills correspond to parameter-efficient (sparse / low-rank) model parameterisations. By jointly learning these and a task-skill allocation matrix, the network for each task is instantiated as the average of the parameters of active skills. To favour non-trivial soft partitions of skills across tasks, we experiment with a series of inductive biases, such as an Indian Buffet Process prior and a two-speed learning rate. We evaluate our latent-skill model on two main settings: 1) multitask reinforcement learning for grounded instruction following on 8 levels of the BabyAI platform; and 2) few-shot adaptation of pre-trained text-to-text generative models on CrossFit, a benchmark comprising 160 NLP tasks. We find that the modular design of a network significantly increases sample efficiency in reinforcement learning and few-shot generalisation in supervised learning, compared to baselines with fully shared, task-specific, or conditionally generated parameters where knowledge is entangled across tasks. In addition, we show how discrete skills help interpretability, as they yield an explicit hierarchy of tasks.</em>";return{c(){t=c("p"),t.textContent=f,s=d(),i=c("p"),i.innerHTML=n},l(o){t=u(o,"P",{"data-svelte-h":!0}),L(t)!=="svelte-1cwsb16"&&(t.textContent=f),s=m(o),i=u(o,"P",{"data-svelte-h":!0}),L(i)!=="svelte-1g6zchw"&&(i.innerHTML=n)},m(o,p){l(o,t,p),l(o,s,p),l(o,i,p)},p:Z,d(o){o&&(a(t),a(s),a(i))}}}function re(y){let t,f="The abstract from the paper is:",s,i,n="<em>Parameter-efficient fine-tuning (PEFT) for cross-task generalization consists in pre-training adapters on a multi-task training set before few-shot adaptation to test tasks. Polytropon [Ponti et al., 2023] (Poly) jointly learns an inventory of adapters and a routing function that selects a (variable-size) subset of adapters for each task during both pre-training and few-shot adaptation. In this paper, we investigate the role that adapter routing plays in its success and design new variants based on our findings. First, we build on the intuition that finer-grained routing provides more expressivity. Hence, we propose MHR (Multi-Head Routing), which combines subsets of adapter parameters and outperforms Poly under a comparable parameter budget; by only fine-tuning the routing function and not the adapters (MHR-z), we achieve competitive performance with extreme parameter efficiency. Second, we find that Poly/MHR performance is a result of better multi-task optimization, rather than modular inductive biases that facilitate adapter recombination and local adaptation, as previously hypothesized. In fact, we find that MHR exhibits higher gradient alignment between tasks than any other method. Since this implies that routing is only crucial during multi-task pre-training, we propose MHR-mu, which discards routing and fine-tunes the average of the pre-trained adapters during few-shot adaptation. This establishes MHR-mu as an effective method for single-adapter fine-tuning.</em>.";return{c(){t=c("p"),t.textContent=f,s=d(),i=c("p"),i.innerHTML=n},l(o){t=u(o,"P",{"data-svelte-h":!0}),L(t)!=="svelte-1cwsb16"&&(t.textContent=f),s=m(o),i=u(o,"P",{"data-svelte-h":!0}),L(i)!=="svelte-1wsh6oc"&&(i.innerHTML=n)},m(o,p){l(o,t,p),l(o,s,p),l(o,i,p)},p:Z,d(o){o&&(a(t),a(s),a(i))}}}function le(y){let t,f,s,i;return t=new Y({props:{id:"paper",option:"Combining Modular Skills in Multitask Learning",$$slots:{default:[se]},$$scope:{ctx:y}}}),s=new Y({props:{id:"paper",option:"Multi-Head Adapter Routing for Cross-Task Generalization",$$slots:{default:[re]},$$scope:{ctx:y}}}),{c(){v(t.$$.fragment),f=d(),v(s.$$.fragment)},l(n){_(t.$$.fragment,n),f=m(n),_(s.$$.fragment,n)},m(n,o){w(t,n,o),l(n,f,o),w(s,n,o),i=!0},p(n,o){const p={};o&2&&(p.$$scope={dirty:o,ctx:n}),t.$set(p);const z={};o&2&&(z.$$scope={dirty:o,ctx:n}),s.$set(z)},i(n){i||(b(t.$$.fragment,n),b(s.$$.fragment,n),i=!0)},o(n){k(t.$$.fragment,n),k(s.$$.fragment,n),i=!1},d(n){n&&a(f),P(t,n),P(s,n)}}}function pe(y){let t,f,s,i,n,o,p,z='<a href="https://hf.co/papers/2202.13914" rel="nofollow">Polytropon</a> is a multitask model with a number of different LoRA adapters in it’s “inventory”. The model learns the correct combination of adapters from the inventory with a routing function to choose the best subset of modules for a specific task. PEFT also supports <a href="https://hf.co/papers/2211.03831" rel="nofollow">Multi-Head Adapter Routing (MHR)</a> for Polytropon which builds on and improves the routing function by combining the adapter heads more granularly. The adapter heads are separated into disjoint blocks and a different routing function is learned for each one, allowing for more expressivity.',N,$,S,M,D,h,x,W,R,J='This is the configuration class to store the configuration of a <a href="/docs/peft/v0.8.2/en/package_reference/poly#peft.PolyModel">PolyModel</a>.',G,A,K='<li><a href="https://arxiv.org/abs/2202.13914" rel="nofollow">Polytropon (Poly)</a></li> <li><a href="https://arxiv.org/abs/2211.03831" rel="nofollow">Multi-Head Routing (MHR)</a></li>',O,C,U,H,T,j,I,F;return n=new V({props:{title:"Polytropon",local:"polytropon",headingTag:"h1"}}),$=new ie({props:{id:"paper",options:["Combining Modular Skills in Multitask Learning","Multi-Head Adapter Routing for Cross-Task Generalization"],$$slots:{default:[le]},$$scope:{ctx:y}}}),M=new V({props:{title:"PolyConfig",local:"peft.PolyConfig",headingTag:"h2"}}),x=new X({props:{name:"class peft.PolyConfig",anchor:"peft.PolyConfig",parameters:[{name:"peft_type",val:": Union = None"},{name:"auto_mapping",val:": Optional = None"},{name:"base_model_name_or_path",val:": Optional = None"},{name:"revision",val:": Optional = None"},{name:"task_type",val:": Union = None"},{name:"inference_mode",val:": bool = False"},{name:"r",val:": int = 8"},{name:"target_modules",val:": Union = None"},{name:"modules_to_save",val:": Optional = None"},{name:"init_weights",val:": bool = True"},{name:"poly_type",val:": Literal = 'poly'"},{name:"n_tasks",val:": int = 1"},{name:"n_skills",val:": int = 4"},{name:"n_splits",val:": int = 1"}],parametersDescription:[{anchor:"peft.PolyConfig.r",description:"<strong>r</strong> (<code>int</code>) &#x2014; Attention dimension of each Lora in Poly.",name:"r"},{anchor:"peft.PolyConfig.target_modules",description:"<strong>target_modules</strong> (<code>Union[List[str],str]</code>) &#x2014; The names of the modules to apply Poly to.",name:"target_modules"},{anchor:"peft.PolyConfig.modules_to_save",description:`<strong>modules_to_save</strong> (<code>List[str]</code>) &#x2014; List of modules apart from Poly layers to be set as trainable
and saved in the final checkpoint.`,name:"modules_to_save"},{anchor:"peft.PolyConfig.init_weights",description:"<strong>init_weights</strong> (bool) &#x2014; Whether to perform initialization of Poly weights.",name:"init_weights"},{anchor:"peft.PolyConfig.poly_type",description:`<strong>poly_type</strong> (<code>Literal[&quot;poly&quot;]</code>) &#x2014; The variant of the Poly module to use. Currently, only &#x201C;poly&#x201D;
is supported.`,name:"poly_type"},{anchor:"peft.PolyConfig.n_tasks",description:"<strong>n_tasks</strong> (<code>int</code>) &#x2014; The number of tasks in a multitasking scenario.",name:"n_tasks"},{anchor:"peft.PolyConfig.n_skills",description:"<strong>n_skills</strong> (<code>int</code>) &#x2014; The number of skills (LoRA) in each Poly layer.",name:"n_skills"},{anchor:"peft.PolyConfig.n_splits",description:`<strong>n_splits</strong> (<code>int</code>) &#x2014; The number of splits within each LoRA of a Poly layer. A value greater
than 1 indicates the use of Multi-Head Routing (MHR).`,name:"n_splits"}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/tuners/poly/config.py#L22"}}),C=new V({props:{title:"PolyModel",local:"peft.PolyModel",headingTag:"h2"}}),T=new X({props:{name:"class peft.PolyModel",anchor:"peft.PolyModel",parameters:[{name:"model",val:""},{name:"config",val:""},{name:"adapter_name",val:""}],source:"https://github.com/huggingface/peft/blob/v0.8.2/src/peft/tuners/poly/model.py#L33"}}),{c(){t=c("meta"),f=d(),s=c("p"),i=d(),v(n.$$.fragment),o=d(),p=c("p"),p.innerHTML=z,N=d(),v($.$$.fragment),S=d(),v(M.$$.fragment),D=d(),h=c("div"),v(x.$$.fragment),W=d(),R=c("p"),R.innerHTML=J,G=d(),A=c("ul"),A.innerHTML=K,O=d(),v(C.$$.fragment),U=d(),H=c("div"),v(T.$$.fragment),j=d(),I=c("p"),this.h()},l(e){const r=ae("svelte-u9bgzb",document.head);t=u(r,"META",{name:!0,content:!0}),r.forEach(a),f=m(e),s=u(e,"P",{}),q(s).forEach(a),i=m(e),_(n.$$.fragment,e),o=m(e),p=u(e,"P",{"data-svelte-h":!0}),L(p)!=="svelte-k0date"&&(p.innerHTML=z),N=m(e),_($.$$.fragment,e),S=m(e),_(M.$$.fragment,e),D=m(e),h=u(e,"DIV",{class:!0});var g=q(h);_(x.$$.fragment,g),W=m(g),R=u(g,"P",{"data-svelte-h":!0}),L(R)!=="svelte-1ekvg8i"&&(R.innerHTML=J),G=m(g),A=u(g,"UL",{"data-svelte-h":!0}),L(A)!=="svelte-pe6nj0"&&(A.innerHTML=K),g.forEach(a),O=m(e),_(C.$$.fragment,e),U=m(e),H=u(e,"DIV",{class:!0});var Q=q(H);_(T.$$.fragment,Q),Q.forEach(a),j=m(e),I=u(e,"P",{}),q(I).forEach(a),this.h()},h(){B(t,"name","hf:doc:metadata"),B(t,"content",fe),B(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),B(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){E(document.head,t),l(e,f,r),l(e,s,r),l(e,i,r),w(n,e,r),l(e,o,r),l(e,p,r),l(e,N,r),w($,e,r),l(e,S,r),w(M,e,r),l(e,D,r),l(e,h,r),w(x,h,null),E(h,W),E(h,R),E(h,G),E(h,A),l(e,O,r),w(C,e,r),l(e,U,r),l(e,H,r),w(T,H,null),l(e,j,r),l(e,I,r),F=!0},p(e,[r]){const g={};r&2&&(g.$$scope={dirty:r,ctx:e}),$.$set(g)},i(e){F||(b(n.$$.fragment,e),b($.$$.fragment,e),b(M.$$.fragment,e),b(x.$$.fragment,e),b(C.$$.fragment,e),b(T.$$.fragment,e),F=!0)},o(e){k(n.$$.fragment,e),k($.$$.fragment,e),k(M.$$.fragment,e),k(x.$$.fragment,e),k(C.$$.fragment,e),k(T.$$.fragment,e),F=!1},d(e){e&&(a(f),a(s),a(i),a(o),a(p),a(N),a(S),a(D),a(h),a(O),a(U),a(H),a(j),a(I)),a(t),P(n,e),P($,e),P(M,e),P(x),P(C,e),P(T)}}}const fe='{"title":"Polytropon","local":"polytropon","sections":[{"title":"PolyConfig","local":"peft.PolyConfig","sections":[],"depth":2},{"title":"PolyModel","local":"peft.PolyModel","sections":[],"depth":2}],"depth":1}';function de(y){return te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ye extends ne{constructor(t){super(),oe(this,t,de,pe,ee,{})}}export{ye as component};
